package com.tmax.openframe.variable.group;

import ch.obermuhlner.math.big.BigDecimalMath;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public @AllArgsConstructor @NoArgsConstructor @Builder(builderClassName = "builder") class OIVPUPDT_PEOPLE_INFO_TEMP {
    public @Getter @Setter int OFWSKEY;
    public @Getter @Builder.Default String OFWS_NAME = StringUtils.repeat(' ',
            10);
    public @Getter @Builder.Default String OFWS_DEPARTMENT = StringUtils
            .repeat(' ', 15);
    public @Getter @Builder.Default String OFWS_PHONE = StringUtils.repeat(' ',
            15);
    public @Getter @Builder.Default String OFWS_EMAIL = StringUtils.repeat(' ',
            20);
    public @Getter @Builder.Default String OFWS_ADDRESS = StringUtils.repeat(
            ' ', 40);
    private final static BiFunction<Long, String, String> intFormatWithSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.applyPattern("+" + format + ";-" + format);
        return nf.format(value);
    };

    public String getStringOFWSKEY() {
        return intFormatWithSign.apply((long) OFWSKEY, "00000000");
    }

    public void setOFWS_NAME(String source) {
        OFWS_NAME = StringUtils.truncate(StringUtils.rightPad(source, 10), 10);
    }

    public void setOFWS_DEPARTMENT(String source) {
        OFWS_DEPARTMENT = StringUtils.truncate(
                StringUtils.rightPad(source, 15), 15);
    }

    public void setOFWS_PHONE(String source) {
        OFWS_PHONE = StringUtils.truncate(StringUtils.rightPad(source, 15), 15);
    }

    public void setOFWS_EMAIL(String source) {
        OFWS_EMAIL = StringUtils.truncate(StringUtils.rightPad(source, 20), 20);
    }

    public void setOFWS_ADDRESS(String source) {
        OFWS_ADDRESS = StringUtils.truncate(StringUtils.rightPad(source, 40),
                40);
    }

    @Override
    public String toString() {
        return String.valueOf(getOFWSKEY()) + getOFWS_NAME()
                + getOFWS_DEPARTMENT() + getOFWS_PHONE() + getOFWS_EMAIL()
                + getOFWS_ADDRESS();
    }
}
